﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

public class Program {

public static void Main(string[] args) {

    ITuple<int, string> tuple = new Tuple<int, string, bool>(1, "One", true);

    ITuple<int, string, bool> t3 = new Tuple<int, string, bool>(1, "One", true);

    ITuple<int, string> t2 = t3;
    t2.Value1 = 5;

    ITuple t = t2;
    W(t.ElementCount);
    W(t);
    foreach(Type tp in t.GetType().GetGenericArguments()){
        W(tp);
    }

    IRandomAccessTuple rat = (IRandomAccessTuple) t2;
    object obj = rat.GetElement(1);
    rat.SetElement(1, "Two");

    IArrayAccessTuple aat = (IArrayAccessTuple) t2;
    aat.SetElements(3, "Three");

    Person p = new Person("John", "Doe", new DateTime(1950, 1, 1));
    INamedAccessTuple nat = p;
    foreach(string sName in nat.GetNames()){
        W(nat.GetElement(sName));
    }

    List<ITuple<string, string, DateTime>> list3 = new List<ITuple<string, string, DateTime>>();
    list3.Add(p);
    list3.Add(new Person("Stella", "Blue", new DateTime(1975, 1, 1)));
    foreach(Person anyPerson in TupleUtil.SelectTuples<string, string, DateTime>(list3, null, "Doe", DateTime.MinValue)){
        W(anyPerson);
    }

    ITuple<string, string, DateTime> match =  new Tuple<string, string, DateTime>(null, "D", DateTime.MinValue);
    foreach(Person anyPerson in TupleUtil.SelectTuples<string, string, DateTime>(
        list3, match, delegate(ITuple<string, string, DateTime> a, ITuple<string, string, DateTime> b){
             return b.Value2.StartsWith(a.Value2);
        })
    )
    {
        W(anyPerson);
    }

    list3.Sort(new TupleComparer<string, string, DateTime>());
    list3.Sort(new TupleComparer<string, string, DateTime>(-1, 2, 3));
    foreach(ITuple<string, string, DateTime> any in list3){
        W(any);
    }

    IList<ITuple<string>> list1 = new List<ITuple<string>>();
    list1.Add(new Tuple<string>("Hello"));
    foreach(ITuple<string> any in TupleUtil.SelectTuples<string>(list1, new Tuple<string>("Hell"), delegate(ITuple<string> a, ITuple<string> b){
        return a.Value1 != null && b.Value1 != null && b.Value1.StartsWith(a.Value1);
    })){
        W(any);
    }

}

private static void W(object obj){
    Console.WriteLine(obj);
}

} // class Program
