using System;

public interface ITuple {

    int ElementCount {get;}

} // interface ITuple

public interface IRandomAccessTuple : ITuple {

    object GetElement(int index);
    void SetElement(int index, object value);

} // interface IRandomAccessTuple

public interface IArrayAccessTuple : ITuple {

    object[] GetElements();
    void SetElements(params object[] values);

} // interface IArrayAccessTuple

public interface INamedAccessTuple : ITuple {

    string[] GetNames();
    object GetElement(string sElementName);
    void SetElement(string sElementName, object value);

} // interface INamedAccessTuple

public interface ITuple<T1> : ITuple {

    T1 Value1{get;set;}

} // interface ITuple<T1>

public interface ITuple<T1, T2> : ITuple<T1> {

    T2 Value2{get;set;}

} // interface ITuple<T1, T2>

public interface ITuple<T1, T2, T3> : ITuple<T1, T2> {

    T3 Value3 {get;set;}

} // interface ITuple<T1, T2, T3>

public interface ITuple<T1, T2, T3, T4> : ITuple<T1, T2, T3> {

    T4 Value4 {get;set;}

} // interface ITuple<T1, T2, T3, T4>

public interface ITuple<T1, T2, T3, T4, T5> : ITuple<T1, T2, T3, T4> {

    T5 Value5{get;set;}

} // interface ITuple<T1, T2, T3, T4, T5>
